#include <windows.h>
#include <windowsx.h>
#include "checkpw.h"
#include "test.h"

void SaveRegistrationInfo(LPCSTR lpUser,LPCSTR lpPassword);
static void CenterDlgBox(HWND hDlg)
    {
    RECT     rect;

    GetWindowRect(hDlg,&rect);
    OffsetRect(&rect,-rect.left,-rect.top);
    MoveWindow(hDlg,
	       ((GetSystemMetrics(SM_CXSCREEN)-rect.right)/2+4)&-7,
	       (GetSystemMetrics(SM_CYSCREEN)-rect.bottom)/2,
	       rect.right,rect.bottom,0);
    }
BOOL __export CALLBACK RegisterDlgProc(HWND  hDlg,UINT  message, WPARAM wParam, LPARAM lParam)
{
switch (message)
	{
    case WM_INITDIALOG:            /* message: initialize dialog box */
		CenterDlgBox(hDlg);
		return TRUE;

	case WM_COMMAND:               /* message: received a command */
		switch(wParam)
			{
			case IDOK:
				{
				char szName[200];
				char szAccess[200];
				char szMessage[]="Improper registration entry\r\nYou must enter Name and Registration Number exactly";
				GetDlgItemText(hDlg,IDC_USER, szName, sizeof(szName));
				GetDlgItemText(hDlg,IDC_SN, szAccess, sizeof(szAccess));
				if(!CheckPassWord(szName, szAccess))
					MessageBox(hDlg,szMessage,"",MB_OK|MB_ICONSTOP);
				else
            	{
					SaveRegistrationInfo(szName, szAccess);
					EndDialog(hDlg, TRUE); /* Exits the dialog box        */
					}
				}
				break;

			case IDCANCEL:
				EndDialog(hDlg, FALSE); /* Exits the dialog box        */
				break;
			}
		break;
	}
return (FALSE);               /* Didn't process a message    */
}

void OnCommand(HWND hDlg, WPARAM wParam)
{
switch(wParam)
	{
	case IDOK:
		EndDialog(hDlg, TRUE); /* Exits the dialog box        */
		break;
	case IDCANCEL:
		EndDialog(hDlg, FALSE); /* Exits the dialog box        */
		break;

	case IDC_REGISTE:
		if(DialogBox(GetWindowInstance(hDlg),MAKEINTRESOURCE(IDD_REGISTER),hDlg,(DLGPROC)RegisterDlgProc))
			EndDialog(hDlg, TRUE); /* Exits the dialog box        */
		break;

	case IDC_REGISTEINFO:
		WinExec("Notepad.exe order.txt",SW_SHOW);
		break;

	default:
		break;
	}
}

BOOL CALLBACK _export About_DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message) {
	case WM_INITDIALOG:		   /* message: initialize dialog box */
		CenterDlgBox(hDlg);
	    return (TRUE);

	case WM_COMMAND:		      /* message: received a command */
		OnCommand(hDlg, wParam);
	    break;
    }
    return (FALSE);			      /* Didn't process a message    */
}

int About(HWND hParent, int DlgID)
{
return DialogBox(GetWindowInstance(hParent), MAKEINTRESOURCE(DlgID),hParent, About_DlgProc);
}


