#include <windows.h>
#include "test.h"
#include "checkpw.h"

HINSTANCE hInst;			    /* current instance			     */

int About(HWND hParent, int DlgID);
LRESULT CALLBACK _export MainWndProc(HWND, UINT, WPARAM, LPARAM);
static char szClass[]="TestWndClass";
static char szIniFile[]="test.ini";
static char szSectPassword[]="Registration";
static char szEntryPassword[]="Password";
static char szEntryUserID[]="UserID";

static BOOL InitApplication(HINSTANCE hInstance)
{
    WNDCLASS  wc;

    /* Fill in window class structure with parameters that describe the       */
    /* main window.                                                           */

    wc.style = NULL;                    /* Class style(s).                    */
    wc.lpfnWndProc = MainWndProc;       /* Function to retrieve messages for  */
                                        /* windows of this class.             */
    wc.cbClsExtra = 0;                  /* No per-class extra data.           */
    wc.cbWndExtra = 0;                  /* No per-window extra data.          */
    wc.hInstance = hInstance;           /* Application that owns the class.   */
    wc.hIcon = NULL;
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH); 
    wc.lpszMenuName =  MAKEINTRESOURCE(IDM_ABOUT);
    wc.lpszClassName = szClass;
    /* Register the window class and return success/failure code. */

    return (RegisterClass(&wc));

}

static BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND            hWnd;               /* Main window handle.                */

    /* Save the instance handle in static variable, which will be used in  */
    /* many subsequence calls from this application to Windows.            */

    hInst = hInstance;

    /* Create a main window for this application instance.  */

    hWnd = CreateWindow(szClass,"Crypt Demo Application",
        WS_OVERLAPPEDWINDOW,                    
        CW_USEDEFAULT,                  
        CW_USEDEFAULT,                  
        CW_USEDEFAULT,                  
        CW_USEDEFAULT,                  
        NULL,                           
        NULL,                           
        hInstance,                      
        NULL                            
    );

    /* If window could not be created, return "failure" */

    if (!hWnd)
        return (FALSE);

    /* Make the window visible; update its client area; and return "success" */

    ShowWindow(hWnd, nCmdShow);  /* Show the window                        */
    UpdateWindow(hWnd);          /* Sends WM_PAINT message                 */
    return (TRUE);               /* Returns the value from PostQuitMessage */

}


int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    MSG msg;				     /* message			     */

	if(!CheckCryptLib())
		{
		MessageBox(NULL,"File is corrupted.","",MB_OK); //in case some hacker get interested in your program
		return (FALSE); 
		}

    if (!hPrevInstance)			 /* Other instances of app running? */
	if (!InitApplication(hInstance)) /* Initialize shared things */
	    return (FALSE);		 /* Exits if unable to initialize     */

    /* Perform initializations that apply to a specific instance */

    if (!InitInstance(hInstance, nCmdShow))
        return (FALSE);

    /* Acquire and dispatch messages until a WM_QUIT message is received. */

    while (GetMessage(&msg,	   /* message structure			     */
	    NULL,		   /* handle of window receiving the message */
	    NULL,		   /* lowest message to examine		     */
	    NULL))		   /* highest message to examine	     */
	{
	TranslateMessage(&msg);	   /* Translates virtual key codes	     */
	DispatchMessage(&msg);	   /* Dispatches message to window	     */
    }
    return (msg.wParam);	   /* Returns the value from PostQuitMessage */
}

BOOL IsRegistered(void)
{
char szPassword[20];
char szUserID[30];
GetPrivateProfileString(szSectPassword, szEntryPassword, "", szPassword, sizeof(szPassword), szIniFile);
GetPrivateProfileString(szSectPassword, szEntryUserID, "", szUserID, sizeof(szUserID), szIniFile);
return CheckPassWord(szUserID, szPassword);
}

void SaveRegistrationInfo(LPCSTR lpUser,LPCSTR lpPassword)
{
WritePrivateProfileString(szSectPassword, szEntryPassword, lpPassword, szIniFile);
WritePrivateProfileString(szSectPassword, szEntryUserID, lpUser,  szIniFile);
}

LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	 switch (message) {
	case  WM_CREATE:
		{
		if(!IsRegistered())
			About(hWnd, IDD_ABOUT1);

		}
		break;

	case WM_COMMAND:	   /* message: command from application menu */
		 if (wParam == IDM_ABOUT){
			About(hWnd, IsRegistered()?IDD_ABOUT:IDD_ABOUT1);
         break;
		 }
		 else			    /* Lets Windows process it	     */
		return (DefWindowProc(hWnd, message, wParam, lParam));

	case WM_DESTROY:		  /* message: window being destroyed */
	    PostQuitMessage(0);
	    break;

	default:			  /* Passes it on if unproccessed    */
	    return (DefWindowProc(hWnd, message, wParam, lParam));
    }
    return (NULL);
}


